#!/bin/sh
#
# Launch Mantidplot using any necessary LD_PRELOAD or software collection behaviour
#
# Script is configured by CMake

# Find out where we are
SCRIPTFILE=$(readlink -f "$0")
INSTALLDIR=$(echo $SCRIPTFILE | sed -r -e 's|^(.*)/(.*)$|\1|g') #.* is greedy and eats up until the final slash

# Define extra libraries and load paths
LOCAL_PRELOAD=/usr/lib64/libtcmalloc_minimal.so.4.1.2
if [ -n "${LD_PRELOAD}" ]; then
    LOCAL_PRELOAD=${LOCAL_PRELOAD}:${LD_PRELOAD}
fi
LOCAL_LDPATH=/usr/lib64/paraview:${LD_LIBRARY_PATH}
if [ -z "${TCMALLOC_RELEASE_RATE}" ]; then
    TCM_RELEASE=10000
else
    TCM_RELEASE=${TCMALLOC_RELEASE_RATE}
fi

# Launch
LD_PRELOAD=${LOCAL_PRELOAD} TCMALLOC_RELEASE_RATE=${TCM_RELEASE} LD_LIBRARY_PATH=${LOCAL_LDPATH} scl enable mantidlibs "$INSTALLDIR/MantidPlot_exe $*"
